/*
 * NFACommon.cpp
 *
 *  Created on: 16. 1. 2014
 *	  Author: Jan Vesely
 */

#include "NFACommon.h"
#include "label/LabelSetLabel.h"

#include <deque>
#include <algorithm>
#include <iostream>

namespace automaton {

namespace determinize {

automaton::State createDFAState(std::set<automaton::State> nfaStates) {
	std::set<label::Label> labelSet;
	for(automaton::State state : std::make_moveable_set(nfaStates)) {
		labelSet.insert(std::move(state.getName()));
	}
	return automaton::State(label::Label(label::LabelSetLabel(std::move(labelSet))));
}

std::set<automaton::State> recreateNFAStates(const automaton::State& dfaState) {
//	std::cout << dfaState << std::endl;
	std::set<automaton::State> states;
	for (const auto& label : static_cast<const label::LabelSetLabel&>(dfaState.getName().getData()).getData()) {
//		std::cout << label << std::endl;
		states.insert(automaton::State(label));
	}
	return states;
}

} /* namespace determinize */

} /* namespace automaton */
