#ifndef RHDPDA_VPA_COMMON_H_
#define RHDPDA_VPA_COMMON_H_

#include "label/Label.h"
#include "automaton/common/State.h"
#include "alphabet/Symbol.h"
#include "string/Epsilon.h"
#include <variant>
#include <set>
#include <map>

namespace automaton {

namespace determinize {

label::Label packToStateLabel(std::set<std::pair<label::Label, label::Label>>&& data);

std::set<std::pair<label::Label, label::Label>> unpackFromStateLabel(const label::Label& data);

label::Label packToStackSymbolLabel(std::pair<std::set<std::pair<label::Label, label::Label>>, alphabet::Symbol>&& data);

std::pair<std::set<std::pair<label::Label, label::Label>>, alphabet::Symbol> unpackFromDVPAStackSymbol(const alphabet::Symbol& symbol);

label::Label packToStackSymbolLabel(std::pair<std::set<std::pair<label::Label, label::Label>>, std::variant<string::Epsilon, alphabet::Symbol>>&& data);

std::pair<std::set<std::pair<label::Label, label::Label>>, std::variant<string::Epsilon, alphabet::Symbol>> unpackFromDRHDPDAStackSymbol(const alphabet::Symbol& symbol);

std::set<label::Label> retrieveDSubSet(const std::set<std::pair<label::Label, label::Label>>& localOperation);

std::set<std::pair<label::Label, label::Label>> createIdentity(std::set<label::Label>&& states);

template<class T, class R>
std::set<automaton::State> existsDirtyState(const T& d, const R& n);

template<class T>
void localClosure(std::set<label::Label>& states, const std::set<label::Label>& oldStates, const T& d);

template<class T, class R>
std::set<std::pair<automaton::State, alphabet::Symbol>> existsDirtyStateSymbol(const T& d, const R& n);

std::set<label::Label> retrieveLabels(const std::set<automaton::State>& states);

} /* namespace determinize */

} /* namespace automaton */

#endif /* RHDPDA_VPA_COMMON_H_ */
