/*
 * MinimizeBrzozowski.cpp
 *
 *  Created on: 18. 11. 2014
 *	  Author: Tomas Pecka
 */
 
#ifndef MINIMIZE_BRZOZOWSKI_H_
#define MINIMIZE_BRZOZOWSKI_H_

#include <automaton/Automaton.h>
#include <automaton/FSM/DFA.h>

namespace automaton {

namespace simplify {

class MinimizeBrzozowski : public automaton::VisitableConstFSMBase {
public:
	MinimizeBrzozowski() {}

	/**
	 * @param dfa automaton to minimize
	 */
	static automaton::Automaton minimize(const automaton::Automaton& dfa);

	static automaton::DFA minimize(const automaton::DFA& dfa);
	static automaton::DFA minimize(const automaton::NFA& nfa);

protected:
	using automaton::VisitableConstFSMBase::Visit;

	void Visit(void*, const automaton::EpsilonNFA& automaton) const;
	void Visit(void*, const automaton::MultiInitialStateNFA& automaton) const;
	void Visit(void*, const automaton::NFA& automaton) const;
	void Visit(void*, const automaton::DFA& automaton) const;
	void Visit(void*, const automaton::ExtendedNFA& automaton) const;
	void Visit(void*, const automaton::CompactNFA& automaton) const;

	static const MinimizeBrzozowski MINIMIZE_BRZOZOWSKI;
};

} /* namespace simplify */

} /* namespace automaton */

#endif /* MINIMIZE_BRZOZOWSKI_H_ */
