/*
 * Normalize.h
 *
 *  Created on: Dec 9, 2013
 *	  Author: Jan Travnicek
 */

#ifndef NORMALIZE_H_
#define NORMALIZE_H_

#include <automaton/FSM/DFA.h>
#include <automaton/PDA/DPDA.h>
#include <automaton/Automaton.h>

namespace automaton {

namespace simplify {

class Normalize : public automaton::VisitableAutomatonBase::const_visitor_type {
public:
	Normalize() {}

	/**
	 * @param dfa automaton to normalize
	 */
	static automaton::Automaton normalize(const automaton::Automaton& dfa);

	static automaton::DFA normalize(const automaton::DFA& dfa);
	static automaton::DPDA normalize(const automaton::DPDA& dfa);


protected:
	void Visit(void*, const automaton::EpsilonNFA& automaton) const;
	void Visit(void*, const automaton::MultiInitialStateNFA& automaton) const;
	void Visit(void*, const automaton::NFA& automaton) const;
	void Visit(void*, const automaton::DFA& automaton) const;
	void Visit(void*, const automaton::ExtendedNFA& automaton) const;
	void Visit(void*, const automaton::CompactNFA& automaton) const;
	void Visit(void*, const automaton::DPDA& automaton) const;
	void Visit(void*, const automaton::SinglePopDPDA& automaton) const;
	void Visit(void*, const automaton::InputDrivenDPDA& automaton) const;
	void Visit(void*, const automaton::InputDrivenNPDA& automaton) const;
	void Visit(void*, const automaton::VisiblyPushdownDPDA& automaton) const;
	void Visit(void*, const automaton::VisiblyPushdownNPDA& automaton) const;
	void Visit(void*, const automaton::RealTimeHeightDeterministicDPDA& automaton) const;
	void Visit(void*, const automaton::RealTimeHeightDeterministicNPDA& automaton) const;
	void Visit(void*, const automaton::NPDA& automaton) const;
	void Visit(void*, const automaton::SinglePopNPDA& automaton) const;
	void Visit(void*, const automaton::OneTapeDTM& automaton) const;
	void Visit(void*, const automaton::DFTA& automaton) const;
	void Visit(void*, const automaton::NFTA& automaton) const;

	static const Normalize NORMALIZE;
};

} /* namespace simplify */

} /* namespace automaton */

#endif /* NORMALIZE_H_ */
