/*
 * Reverse.h
 *
 *  Created on: 7. 11. 2014
 *	  Author: Tomas Pecka
 */

#ifndef REVERSE_H_
#define REVERSE_H_

#include <automaton/Automaton.h>
#include <automaton/common/State.h>

namespace automaton {

namespace transform {

class Reverse : public automaton::VisitableConstFSMBase {
public:
	Reverse() {}

	static automaton::MultiInitialStateNFA convert(const automaton::DFA& automaton);
	static automaton::MultiInitialStateNFA convert(const automaton::NFA& automaton);
	static automaton::MultiInitialStateNFA convert(const automaton::MultiInitialStateNFA& automaton);

	/**
	 * Creates finite automaton accepting reverse language of given automaton
	 * @param automaton FSM
	 * @return Automaton reverse automaton
	 */
	static automaton::Automaton convert( const automaton::Automaton & automaton );
private:
	using automaton::VisitableConstFSMBase::Visit;

	void Visit(void*, const DFA& automaton) const;
	void Visit(void*, const NFA& automaton) const;
	void Visit(void*, const MultiInitialStateNFA& automaton) const;
	void Visit(void*, const ExtendedNFA& automaton) const;
	void Visit(void*, const EpsilonNFA& automaton) const;
	void Visit(void*, const CompactNFA& automaton) const;

	static const Reverse REVERSE;
};

} /* namespace transform */

} /* namespace automaton */

#endif /* REVERSE_H_ */
