/*
 * ToAutomatonBototmUp.h
 *
 * Created on: 20. 5. 2015
 * Author: Tomas Pecka
 */

#ifndef _GRAMMAR_TO_AUTOMATON_BOTTOMUP_H_
#define _GRAMMAR_TO_AUTOMATON_BOTTOMUP_H_

#include <grammar/Grammar.h>
#include <grammar/Regular/LeftRG.h>
#include <grammar/Regular/RightRG.h>
#include <grammar/ContextFree/CFG.h>
#include <grammar/ContextFree/EpsilonFreeCFG.h>

#include <automaton/Automaton.h>
#include <automaton/FSM/NFA.h>
#include <automaton/PDA/NPDA.h>

namespace grammar {

namespace convert {

/**
 */
class ToAutomatonBottomUp : public grammar::VisitableGrammarBase::const_visitor_type {
public:
	ToAutomatonBottomUp() {}

	/**
	 * Performs conversion.
	 */
	static automaton::Automaton convert(const grammar::Grammar& grammar);

	template <class T>
	static automaton::NPDA convert(const T& grammar);

private:
	void Visit(void*, const grammar::RightRG& grammar) const;
	void Visit(void*, const grammar::LeftRG& grammar) const;
	void Visit(void*, const grammar::RightLG& grammar) const;
	void Visit(void*, const grammar::LeftLG& grammar) const;
	void Visit(void*, const grammar::LG& grammar) const;
	void Visit(void*, const grammar::CFG& grammar) const;
	void Visit(void*, const grammar::EpsilonFreeCFG& grammar) const;
	void Visit(void*, const grammar::CNF& grammar) const;
	void Visit(void*, const grammar::GNF& grammar) const;
	void Visit(void*, const grammar::CSG& grammar) const;
	void Visit(void*, const grammar::NonContractingGrammar& grammar) const;
	void Visit(void*, const grammar::ContextPreservingUnrestrictedGrammar& grammar) const;
	void Visit(void*, const grammar::UnrestrictedGrammar& grammar) const;

	static const ToAutomatonBottomUp TO_AUTOMATON_BOTTOMUP;
};

} /* namespace convert */

} /* namespace grammar */

#endif /* _GRAMMAR_TO_AUTOMATON_BOTTOMUP_H_ */
