/*
 * ToGrammarLeftRG.h
 *
 *  Created on: 8. 3. 2014
 *	  Author: Tomas Pecka
 */

#ifndef TO_GRAMMAR_LEFT_RG_H_
#define TO_GRAMMAR_LEFT_RG_H_

#include <grammar/Grammar.h>
#include <grammar/Regular/LeftRG.h>
#include <grammar/Regular/RightRG.h>

namespace grammar {

namespace convert {

/**
 * Converts right regular grammar to left regular grammar.
 */
class ToGrammarLeftRG : public grammar::VisitableConstRGBase
{
public:
	ToGrammarLeftRG() {}

	/**
	 * Performs conversion.
	 * @param grammar Right regular grammar to convert
	 * @return left regular grammar which is equivalent to source right regular grammar.
	 */
	static grammar::LeftRG convert(const grammar::Grammar& grammar);
	static grammar::LeftRG convert(const grammar::RightRG& grammar);

private:
	using grammar::VisitableConstRGBase::Visit;

	void Visit(void*, const grammar::RightRG& grammar) const;
	void Visit(void*, const grammar::LeftRG& grammar) const;
	void Visit(void*, const grammar::RightLG& grammar) const;
	void Visit(void*, const grammar::LeftLG& grammar) const;

	static const ToGrammarLeftRG TO_GRAMMAR_LEFT_RG;
};

} /* namespace convert */

} /* namespace grammar */

#endif /* TO_GRAMMAR_LEFT_RG_H_ */
