/*
 * ToGrammarRightRG.h
 *
 *  Created on: 8. 3. 2014
 *	  Author: Tomas Pecka
 */

#ifndef TO_GRAMMAR_RIGHT_RG_H_
#define TO_GRAMMAR_RIGHT_RG_H_

#include <grammar/Grammar.h>
#include <grammar/Regular/LeftRG.h>
#include <grammar/Regular/RightRG.h>

namespace grammar {

namespace convert {

/**
 * Converts left regular grammar to right regular grammar.
 */
class ToGrammarRightRG : public grammar::VisitableConstRGBase
{
public:
	ToGrammarRightRG() {}

	/**
	 * Performs conversion.
	 * @param grammar Left regular grammar to convert
	 * @return right regular grammar which is equivalent to source left regular grammar.
	 */
	static grammar::RightRG convert(const grammar::Grammar& grammar);
	static grammar::RightRG convert(const grammar::LeftRG& grammar);

private:
	using grammar::VisitableConstRGBase::Visit;

	void Visit(void*, const grammar::RightRG& grammar) const;
	void Visit(void*, const grammar::LeftRG& grammar) const;
	void Visit(void*, const grammar::RightLG& grammar) const;
	void Visit(void*, const grammar::LeftLG& grammar) const;

	static const ToGrammarRightRG TO_GRAMMAR_RIGHT_RG;
};

} /* namespace convert */

} /* namespace grammar */

#endif /* TO_GRAMMAR_RIGHT_RG_H_ */
