/*
 * ToRegExp.cpp
 *
 *  Created on: 4. 3. 2014
 *	  Author: Tomas Pecka
 */

#include "ToRegExp.h"
#include "ToRegExpAlgebraic.h"
#include <exception/AlibException.h>

namespace grammar {

namespace convert {

regexp::RegExp ToRegExp::convert(const grammar::Grammar& grammar)
{
	regexp::RegExp* out = NULL;
	grammar.getData().Accept((void*) &out, ToRegExp::TO_REG_EXP);
	regexp::RegExp res = std::move(*out);
	delete out;
	return res;
}

void ToRegExp::Visit(void* userData, const grammar::RightRG& grammar) const
{
	regexp::RegExp* & out = *((regexp::RegExp**) userData);
	out = new regexp::RegExp(ToRegExpAlgebraic::convert(grammar));
}

void ToRegExp::Visit(void* userData, const grammar::LeftRG& grammar) const
{
	regexp::RegExp* & out = *((regexp::RegExp**) userData);
	out = new regexp::RegExp(ToRegExpAlgebraic::convert(grammar));
}

void ToRegExp::Visit(void*, const grammar::RightLG&) const
{
	throw exception::AlibException("Unsupported grammar type RightLG");
}

void ToRegExp::Visit(void*, const grammar::LeftLG&) const
{
	throw exception::AlibException("Unsupported grammar type LeftLG");
}

const ToRegExp ToRegExp::TO_REG_EXP;

} /* namespace convert */

} /* namespace grammar */
