/*
 * ToRegExpAlgebraic.h
 *
 *  Created on: 4. 3. 2014
 *	  Author: Tomas Pecka
 */

#ifndef GRAMMAR_TO_REG_EXP_ALGEBRAIC_H_
#define GRAMMAR_TO_REG_EXP_ALGEBRAIC_H_

#include <grammar/Grammar.h>
#include <grammar/Regular/RightRG.h>
#include <grammar/Regular/LeftRG.h>

#include <regexp/RegExp.h>

namespace grammar {

namespace convert {

class ToRegExpAlgebraic : public grammar::VisitableConstRGBase
{
public:
	ToRegExpAlgebraic() {}

	/**
	 * @return regexp equivalent to source right regular grammar.
	 * @param grammar Grammar to convert
	 */
	static regexp::RegExp convert(const grammar::Grammar& grammar);

	static regexp::RegExp convert(const grammar::RightRG& grammar);
	static regexp::RegExp convert(const grammar::LeftRG& grammar);

protected:
	using grammar::VisitableConstRGBase::Visit;

	void Visit(void*, const grammar::RightRG& grammar) const;
	void Visit(void*, const grammar::LeftRG& grammar) const;
	void Visit(void*, const grammar::RightLG& grammar) const;
	void Visit(void*, const grammar::LeftLG& grammar) const;

	static const ToRegExpAlgebraic TO_REG_EXP_ALGEBRAIC;
};

} /* namespace covert */

} /* namespace grammar */

#endif /* GRAMMAR_TO_REG_EXP_ALGEBRAIC_H_ */
