#ifndef GRAPH_TOPOLOGICAL_SORT_H_
#define GRAPH_TOPOLOGICAL_SORT_H_

#include <list>

#include <graph/Graph.h>
#include <graph/directed/DirectedGraph.h>
#include <graph/undirected/UndirectedGraph.h>

namespace graph
{

namespace sort
{

class TopologicalSort : public graph::VisitableGraphBase::const_visitor_type
{
public:
	TopologicalSort() {}

	typedef std::list<Node> Result;

	static Result topologicalsort(const Graph &graph);

	static Result topologicalsort(const DirectedGraph &graph);

private:
	void Visit(void *data, const DirectedGraph &graph) const;
	void Visit(void *data, const UndirectedGraph &graph) const;

	static const TopologicalSort TOPOLOGICAL_SORT;
};

} // namespace sort

} // namespace graph

#endif // GRAPH_TOPOLOGICAL_SORT_H_
