#ifndef GRAPH_JARNIK_PRIM_H_
#define GRAPH_JARNIK_PRIM_H_

#include <graph/Graph.h>
#include <graph/directed/DirectedGraph.h>
#include <graph/undirected/UndirectedGraph.h>

namespace graph
{

namespace spanningtree
{

class JarnikPrim : public graph::VisitableGraphBase::const_visitor_type
{
public:
	JarnikPrim() {}

	static Graph jarnikprim(const Graph &graph, const Node &start);

	static UndirectedGraph jarnikprim(const UndirectedGraph &graph, const Node &start);

private:
	void Visit(void *data, const DirectedGraph &graph) const;
	void Visit(void *data, const UndirectedGraph &graph) const;

	static const JarnikPrim JARNIK_PRIM;
};

} // namespace spanningtree

} // namespace graph

#endif // GRAPH_JARNIK_PRIM_H_
