/*
 * ToAutomaton.cpp
 *
 *  Created on: 11. 1. 2014
 *	  Author: Jan Travnicek
 */

#include "ToAutomaton.h"
#include "ToAutomatonGlushkov.h"
#include <exception/AlibException.h>

namespace regexp {

namespace convert {

automaton::Automaton ToAutomaton::convert(const regexp::RegExp& regexp)
{
	automaton::Automaton* out = NULL;
	regexp.getData().Accept((void*) &out, ToAutomaton::TO_AUTOMATON);
	automaton::Automaton res = std::move(*out);
	delete out;
	return res;
}

void ToAutomaton::Visit(void* userData, const regexp::FormalRegExp& regexp) const
{
	automaton::Automaton* &out = *((automaton::Automaton**) userData);
	out = new automaton::Automaton(ToAutomatonGlushkov::convert(regexp));
}
void ToAutomaton::Visit(void* userData, const regexp::UnboundedRegExp& regexp) const
{
	automaton::Automaton* &out = *((automaton::Automaton**) userData);
	out = new automaton::Automaton(ToAutomatonGlushkov::convert(regexp));
}

const ToAutomaton ToAutomaton::TO_AUTOMATON;

} /* namespace convert */

} /* namespace regexp */
