/*
 * RegExpToAutomaton.h
 *
 *  Created on: 11. 1. 2014
 *	  Author: Tomas Pecka
 */

#ifndef REG_EXP_TO_AUTOMATON_H_
#define REG_EXP_TO_AUTOMATON_H_

#include <regexp/RegExp.h>
#include <regexp/formal/FormalRegExp.h>
#include <regexp/unbounded/UnboundedRegExp.h>

#include <automaton/Automaton.h>
#include <automaton/FSM/NFA.h>

namespace regexp {

namespace convert {

class ToAutomaton : public regexp::VisitableRegExpBase::const_visitor_type
{
public:
	ToAutomaton() {}

	/**
	 * Performs conversion.
	 * @return FSM equivalent to original regular expression.
	 */
	static automaton::Automaton convert(const regexp::RegExp& regexp);

private:
	void Visit(void*, const regexp::FormalRegExp& regexp) const;
	void Visit(void*, const regexp::UnboundedRegExp& regexp) const;

	static const ToAutomaton TO_AUTOMATON;
};

} /* namespace convert */

} /* namespace regexp */

#endif /* REG_EXP_TO_AUTOMATON_H_ */
