/*
 * ToGrammar.cpp
 *
 *  Created on: 6. 3. 2014
 *	  Author: Jan Travnicek
 */

#include "ToGrammar.h"
#include "ToGrammarRightRGGlushkov.h"
#include <exception/AlibException.h>

namespace regexp {

namespace convert {

grammar::Grammar ToGrammar::convert(const regexp::RegExp& regexp)
{
	grammar::Grammar* out = NULL;
	regexp.getData().Accept((void*) &out, ToGrammar::TO_GRAMMAR);
	grammar::Grammar res = std::move(*out);
	delete out;
	return res;
}

void ToGrammar::Visit(void* userData, const regexp::FormalRegExp& regexp) const
{
	grammar::Grammar* &out = *((grammar::Grammar**) userData);
	out = new grammar::Grammar(ToGrammarRightRGGlushkov::convert(regexp));
}

void ToGrammar::Visit(void* userData, const regexp::UnboundedRegExp& regexp) const
{
	grammar::Grammar* &out = *((grammar::Grammar**) userData);
	out = new grammar::Grammar(ToGrammarRightRGGlushkov::convert(regexp));
}

const ToGrammar ToGrammar::TO_GRAMMAR;

} /* namespace convert */

} /* namespace regexp */
