/*
 * ToGrammar.h
 *
 *  Created on: 6. 3. 2014
 *	  Author: Jan Travnicek
 */

#ifndef REG_EXP_TO_GRAMMAR_H_
#define REG_EXP_TO_GRAMMAR_H_

#include <grammar/Grammar.h>
#include <regexp/RegExp.h>

namespace regexp {

namespace convert {

class ToGrammar : public regexp::VisitableRegExpBase::const_visitor_type
{
public:
	ToGrammar() {}

	/**
	 * Performs conversion.
	 * @return right regular grammar equivalent to source regexp.
	 */
	static grammar::Grammar convert(const regexp::RegExp& regexp);

private:
	void Visit(void*, const regexp::FormalRegExp& regexp) const;
	void Visit(void*, const regexp::UnboundedRegExp& regexp) const;

	static const ToGrammar TO_GRAMMAR;
};

} /* namespace convert */

} /* namespace regexp */

#endif /* REG_EXP_TO_GRAMMAR_H_ */
