/*
 * RegExpAlternate.cpp
 *
 *  Created on: 17. 10. 2014
 *	  Author: Jan Travnicek
 */

#include "RegExpAlternate.h"
#include "regexp/formal/FormalRegExpAlternation.h"
#include "regexp/unbounded/UnboundedRegExpAlternation.h"

namespace regexp
{

regexp::RegExp RegExpAlternate::alternate(const regexp::RegExp& first, const regexp::RegExp& second) {
	return getInstance().dispatch(first.getData(), second.getData());
}

regexp::FormalRegExp RegExpAlternate::alternate(const regexp::FormalRegExp& first, const regexp::FormalRegExp& second) {
	return regexp::FormalRegExp(regexp::FormalRegExpAlternation(first.getRegExp(), second.getRegExp()));
}

auto RegExpAlternateFormalRegExp = RegExpAlternate::RegistratorWrapper<regexp::FormalRegExp, regexp::FormalRegExp>(RegExpAlternate::getInstance(), RegExpAlternate::alternate);

regexp::UnboundedRegExp RegExpAlternate::alternate(const regexp::UnboundedRegExp& first, const regexp::UnboundedRegExp& second) {
	regexp::UnboundedRegExpAlternation con;
	con.appendElement(first.getRegExp());
	con.appendElement(second.getRegExp());
	return regexp::UnboundedRegExp(con);
}

auto RegExpAlternateUnboundedRegExp = RegExpAlternate::RegistratorWrapper<regexp::UnboundedRegExp, regexp::UnboundedRegExp>(RegExpAlternate::getInstance(), RegExpAlternate::alternate);

} /* namespace regexp */
