/*
 * RegExpAlternate.h
 *
 *  Created on: 17. 10. 2014
 *	  Author: Jan Travnicek
 */

#ifndef REG_EXP_ALTERNATE_H_
#define REG_EXP_ALTERNATE_H_

#include <common/multipleDispatch.hpp>

#include <regexp/RegExp.h>
#include <regexp/formal/FormalRegExp.h>
#include <regexp/unbounded/UnboundedRegExp.h>

namespace regexp {

/**
 * Alternates two regexpses
 *
 */
class RegExpAlternate : public std::PromotingDoubleDispatch<regexp::RegExp, regexp::RegExpBase> {
public:
	static regexp::RegExp alternate(const regexp::RegExp& first, const regexp::RegExp& second);

	static regexp::FormalRegExp alternate(const regexp::FormalRegExp& first, const regexp::FormalRegExp& second);
	static regexp::UnboundedRegExp alternate(const regexp::UnboundedRegExp& first, const regexp::UnboundedRegExp& second);

	static RegExpAlternate& getInstance() {
		static RegExpAlternate res;
		return res;
	}
};

} /* namespace regexp */

#endif /* REG_EXP_ALTERNATE_H_ */
