/*
 * RegExpConcatenate.cpp
 *
 *  Created on: 17. 10. 2014
 *	  Author: Jan Travnicek
 */

#include "RegExpConcatenate.h"
#include "regexp/formal/FormalRegExpConcatenation.h"
#include "regexp/unbounded/UnboundedRegExpConcatenation.h"

namespace regexp
{

regexp::RegExp RegExpConcatenate::concatenate(const regexp::RegExp& first, const regexp::RegExp& second) {
	return getInstance().dispatch(first.getData(), second.getData());
}

regexp::FormalRegExp RegExpConcatenate::concatenate(const regexp::FormalRegExp& first, const regexp::FormalRegExp& second) {
	return regexp::FormalRegExp(regexp::FormalRegExpConcatenation(first.getRegExp(), second.getRegExp()));
}

auto RegExpConcatenateFormalRegExp = RegExpConcatenate::RegistratorWrapper<regexp::FormalRegExp, regexp::FormalRegExp>(RegExpConcatenate::getInstance(), RegExpConcatenate::concatenate);

regexp::UnboundedRegExp RegExpConcatenate::concatenate(const regexp::UnboundedRegExp& first, const regexp::UnboundedRegExp& second) {
	regexp::UnboundedRegExpConcatenation con;
	con.appendElement(first.getRegExp());
	con.appendElement(second.getRegExp());
	return regexp::UnboundedRegExp(con);
}

auto RegExpConcatenateUnboundedRegExp = RegExpConcatenate::RegistratorWrapper<regexp::UnboundedRegExp, regexp::UnboundedRegExp>(RegExpConcatenate::getInstance(), RegExpConcatenate::concatenate);

} /* namespace regexp */
