/*
 * RegExpIterate.h
 *
 *  Created on: 17. 10. 2014
 *	  Author: Jan Travnicek
 */

#ifndef REG_EXP_ITERATE_H_
#define REG_EXP_ITERATE_H_

#include <common/multipleDispatch.hpp>

#include <regexp/RegExp.h>
#include <regexp/formal/FormalRegExp.h>
#include <regexp/unbounded/UnboundedRegExp.h>

namespace regexp
{

/**
 * Iterates two regexpses
 *
 */
class RegExpIterate : public std::SingleDispatch<regexp::RegExp, regexp::RegExpBase> {
public:
	static regexp::RegExp iterate(const regexp::RegExp& regexp);

	static regexp::FormalRegExp iterate(const regexp::FormalRegExp& regexp);
	static regexp::UnboundedRegExp iterate(const regexp::UnboundedRegExp& regexp);

	static RegExpIterate& getInstance() {
		static RegExpIterate res;
		return res;
	}
};

} /* namespace regexp */

#endif /* REG_EXP_ITERATE_H_ */
