/*
 * ExactEqual.h
 *
 *  Created on: Oct 14, 2014
 *	  Author: Radomir Polach
 */

#ifndef EXACT_EQUAL_H_
#define EXACT_EQUAL_H_

#include <string/String.h>

namespace string {

namespace naive {

class ExactEqual : public string::VisitableStringBase::const_promoting_visitor_type {
public:
	ExactEqual() {}

	static bool equals(const string::String& u, const string::String& v);
	
	static bool equals(const string::Epsilon& u, const string::Epsilon& v);
	static bool equals(const string::LinearString& u, const string::LinearString& v);
	static bool equals(const string::CyclicString& u, const string::CyclicString& v);

private:
	void Visit(void*, const Epsilon& u, const Epsilon& v) const;
	void Visit(void*, const LinearString& u, const LinearString& v) const;
	void Visit(void*, const CyclicString& u, const CyclicString& v) const;

	static const ExactEqual EXACT_EQUAL;
};

} /* namespace naive */

} /* namespace string */

#endif /* EXACT_EQUAL_H_ */
