/*
 * NormalizeAlphabet.h
 *
 *  Created on: Dec 9, 2013
 *	  Author: Jan Travnicek
 */

#ifndef NORMALIZE_ALPHABET_H_
#define NORMALIZE_ALPHABET_H_

#include <string/LinearString.h>
#include <string/String.h>

namespace string {

namespace simplify {

class NormalizeAlphabet : public string::VisitableStringBase::const_visitor_type {
public:
	NormalizeAlphabet() {}

	/**
	 * @param dfa automaton to normalize
	 */
	static string::String normalize(const string::String& str);

	static string::LinearString normalize(const string::LinearString& str);

protected:
	void Visit(void*, const string::Epsilon& string) const;
	void Visit(void*, const string::LinearString& string) const;
	void Visit(void*, const string::CyclicString& string) const;

	static const NormalizeAlphabet NORMALIZE;
};

} /* namespace simplify */

} /* namespace string */

#endif /* NORMALIZE_ALPHABET_H_ */
