/*
 * NormalizeRotation.h
 *
 *  Created on: 9. 2. 2014
 *      Author: Jan Travnicek
 */

#ifndef _NORMALIZE_ROTATION_H__
#define _NORMALIZE_ROTATION_H__

#include <string/String.h>

namespace string {

namespace simplify {

class NormalizeRotation : public string::VisitableStringBase::const_visitor_type {
public:
	NormalizeRotation() {}

	/**
	 * Performs conversion.
	 * @return left regular grammar equivalent to source automaton.
	 */
	static string::String normalize(const string::String& string);

	static string::CyclicString normalize(const string::CyclicString& string);
private:
	void Visit(void*, const Epsilon& string) const;
	void Visit(void*, const LinearString& string) const;
	void Visit(void*, const CyclicString& string) const;

	static const NormalizeRotation NORMALIZE_ROTATION;
};

} /* namespace simplify */

} /* namespace string */

#endif /* _NORMALIZE_ROTATION_H__ */
