/*
 * ExactMatchingAutomaton.h
 *
 *  Created on: 9. 2. 2014
 *      Author: Jan Travnicek
 */

#ifndef _EXACT_MATCHING_AUTOMATON_H__
#define _EXACT_MATCHING_AUTOMATON_H__

#include <automaton/Automaton.h>
#include <automaton/FSM/NFA.h>
#include <string/LinearString.h>
#include <string/String.h>
#include <common/multipleDispatch.hpp>

namespace stringology {

namespace exact {

class ExactMatchingAutomaton : public std::SingleDispatch<automaton::Automaton, string::StringBase> {
public:
	/**
	 * Performs conversion.
	 * @return left regular grammar equivalent to source automaton.
	 */
	static automaton::Automaton construct(const string::String& pattern);

	static automaton::NFA construct(const string::LinearString& pattern);

	static ExactMatchingAutomaton& getInstance() {
		static ExactMatchingAutomaton res;
		return res;
	}
};

} /* namespace exact */

} /* namespace stringology */

#endif /* _EXACT_MATCHING_AUTOMATON_H__ */
