#include "JarnikPrimTest.h"

#include "graph/spanningtree/JarnikPrim.h"

#include <iostream>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( GraphJarnikPrimTest, "graph" );
CPPUNIT_TEST_SUITE_REGISTRATION( GraphJarnikPrimTest );

void GraphJarnikPrimTest::testSpanningTree1()
{
	graph::Node n1("n1");
	graph::Node n2("n2");
	graph::Node n3("n3");
	graph::Node n4("n4");
	graph::Node n5("n5");
	graph::Node n6("n6");

	graph::UndirectedGraph ug;
	ug.addEdge(graph::UndirectedEdge(n1, n2), 3);
	ug.addEdge(graph::UndirectedEdge(n1, n3), 6);
	ug.addEdge(graph::UndirectedEdge(n1, n4), 1);
	ug.addEdge(graph::UndirectedEdge(n2, n4), 5);
	ug.addEdge(graph::UndirectedEdge(n2, n5), 3);
	ug.addEdge(graph::UndirectedEdge(n3, n4), 5);
	ug.addEdge(graph::UndirectedEdge(n3, n6), 2);
	ug.addEdge(graph::UndirectedEdge(n4, n5), 6);
	ug.addEdge(graph::UndirectedEdge(n4, n6), 4);
	ug.addEdge(graph::UndirectedEdge(n5, n6), 6);

	graph::UndirectedGraph res;
	res = graph::spanningtree::JarnikPrim::jarnikprim(ug, n1);

	graph::UndirectedGraph expected;
	expected.addEdge(graph::UndirectedEdge(n1, n2), 3);
	expected.addEdge(graph::UndirectedEdge(n1, n4), 1);
	expected.addEdge(graph::UndirectedEdge(n2, n5), 3);
	expected.addEdge(graph::UndirectedEdge(n4, n6), 4);
	expected.addEdge(graph::UndirectedEdge(n6, n3), 2);

	std::cout << expected << std::endl;
	std::cout << res << std::endl;

	CPPUNIT_ASSERT(expected == res);
}

