/*
 * Automaton.cpp
 *
 *  Created on: Apr 16, 2013
 *      Author: Martin Zak
 */

#include "Automaton.h"
#include "common/State.h"
#include <climits>
#include "AutomatonException.h"

namespace automaton {

State createUniqueState(State nextState, const std::set<State>& other) {
	int i = 0;
	do {
		nextState.getName().inc();
		if(other.count(nextState) == 0)
			return std::move(nextState);
	} while(++i < INT_MAX);

	throw AutomatonException("Could not create unique state." );
}

} /* namespace automaton */

