/*
 * Automaton.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Martin Zak
 */

#ifndef AUTOMATON_H_
#define AUTOMATON_H_

#include "../object/WrapperBase.h"
#include "AutomatonBase.h"
#include "../common/wrapper.hpp"

#include "AutomatonFeatures.h"
#include <set>

namespace automaton {

/**
 * Wrapper around automata.
 */
class Automaton : public alib::wrapper<AutomatonBase>, public alib::WrapperBase {
	using alib::wrapper<AutomatonBase>::wrapper;
};

State createUniqueState(State base, const std::set<State>& other);

} /* namespace automaton */

namespace std {

template<>
struct compare<automaton::Automaton> {
	int operator()(const automaton::Automaton& first, const automaton::Automaton& second) const {
		return first.getData().compare(second.getData());
	}
};

} /* namespace std */

#endif /* AUTOMATON_H_ */

