/*
 * SingleInitialState.cpp
 *
 *  Created on: Apr 16, 2013
 *      Author: Jan Travnicek
 */

#include "SingleInitialState.h"

#include "../AutomatonException.h"

namespace automaton {

SingleInitialState::SingleInitialState(State initialState) : initialState(initialState) {
	addState(std::move(initialState));
}

void SingleInitialState::setInitialState(State state) {
	if (!states.count(state)) {
		throw AutomatonException("State " + (std::string) state.getName() + " cannot be set as initial state. It is not present in the automaton.");
	}

	initialState = std::move(state);
}

const State& SingleInitialState::getInitialState() const {
	return initialState;
}

} /* namespace automaton */

