/*
 * GraphFeatures.h
 *
 *  Created on: Jun 19, 2014
 *      Author: David Rosca
 */

#ifndef GRAPH_BASE_H_
#define GRAPH_BASE_H_

#include "common/Macros.h"
#include "../object/ObjectBase.h"

namespace graph {

class GraphBase;

// ----------------------------------------------------------------------------------------------------------------------

template<typename T>
class acceptor_base_helper {
};

template<typename ... Ts>
class acceptor_base_helper< std::tuple< Ts ... > > :
	public std::acceptor_base<
			GraphBase, Ts ...
	> {
};

typedef acceptor_base_helper< alib::GraphTypes > VisitableGraphBase;

// ----------------------------------------------------------------------------------------------------------------------

/**
 * Represents symbol in an alphabet.
 */
class GraphBase : public alib::ObjectBase, public VisitableGraphBase {
public:
	using VisitableGraphBase::Accept;
	using alib::VisitableObjectBase::Accept;

	virtual GraphBase* clone() const = 0;
	virtual GraphBase* plunder() && = 0;
};

} // namespace graph

GRAPH_DEFINE_STD_COMPARE(GraphBase)

#endif // GRAPH_BASE_H_
