/*
 * GraphFeatures.h
 *
 *  Created on: Jun 19, 2014
 *      Author: David Rosca
 */

#include "GraphRepresentation.h"

namespace graph {

std::string representationToString(REPRESENTATION r)
{
	switch (r) {
	case REPRESENTATION::ADJACENCY_LIST:
		return "AdjacencyList";
	case REPRESENTATION::ADJACENCY_MATRIX:
		return "AdjacencyMatrix";
	case REPRESENTATION::INCIDENCE_MATRIX:
		return "IncidenceMatrix";
	default:
		return "AdjacencyList";
	}
}

REPRESENTATION representationFromString(const std::string &str)
{
	if (str == "AdjacencyList") {
		return REPRESENTATION::ADJACENCY_LIST;
	} else if (str == "AdjacencyMatrix") {
		return REPRESENTATION::ADJACENCY_MATRIX;
	} else if (str == "IncidenceMatrix") {
		return REPRESENTATION::INCIDENCE_MATRIX;
	}
	return REPRESENTATION::ADJACENCY_LIST;
}

} // namespace graph
