#ifndef NODE_H_
#define NODE_H_

#include "Macros.h"
#include "../../label/Label.h"

namespace graph {

class Node
{
public:
	explicit Node(label::Label name);
	explicit Node(int number);
	explicit Node(char character);
	explicit Node(const std::string &name);

	Node *clone() const;
	Node *plunder() &&;

	const label::Label &getName() const;

	bool operator < (const Node& other) const;
	bool operator == (const Node& other) const;
	bool operator != (const Node& other) const;
	int compare(const Node &other) const;

	void operator>>(std::ostream &out) const;

	explicit operator std::string() const;

	friend std::ostream &operator<<(std::ostream &out, const Node &node);

private:
	void dump(std::ostream &os) const;

	label::Label name;
};

} // namespace graph

GRAPH_DEFINE_STD_HASH(Node)
GRAPH_DEFINE_STD_COMPARE(Node)

#endif // NODE_H_
