/*
 * LabelBase.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef LABEL_BASE_H_
#define LABEL_BASE_H_

#include "../object/ObjectBase.h"

namespace label {

class LabelBase;

// ----------------------------------------------------------------------------------------------------------------------

template<typename T>
class acceptor_base_helper {
};

template<typename ... Ts>
class acceptor_base_helper< std::tuple< Ts ... > > :
	public std::acceptor_base<
			LabelBase, Ts ...
	> {
};

typedef acceptor_base_helper< alib::LabelTypes > VisitableLabelBase;

// ----------------------------------------------------------------------------------------------------------------------

/**
 * Represents symbol in an alphabet.
 */
class LabelBase : public alib::ObjectBase, public VisitableLabelBase {
public:
	using VisitableLabelBase::Accept;
	using alib::VisitableObjectBase::Accept;

	virtual LabelBase* clone() const = 0;
	virtual LabelBase* plunder() && = 0;

	virtual LabelBase* next() const = 0;
	virtual LabelBase* inc() && = 0;
};

} /* namespace label */

namespace std {

template<>
struct compare<label::LabelBase> {
	int operator()(const label::LabelBase& first, const label::LabelBase& second) const {
		return first.compare(second);
	}
};

} /* namespace std */

#endif /* LABEL_BASE_H_ */

