/*
 * Void.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#include "Void.h"
#include "../sax/FromXMLParserHelper.h"
#include "Object.h"
#include "../XmlApi.hpp"

namespace alib {

Void::Void() {

}

ObjectBase* Void::clone() const {
	return new Void(*this);
}

ObjectBase* Void::plunder() && {
	return new Void(std::move(*this));
}

int Void::compare(const Void&) const {
	return 0;
}

void Void::operator>>(std::ostream& out) const {
	out << "(Void)";
}

Void::operator std::string () const {
	return "V";
}

Void Void::VOID = Void();

const std::string Void::XML_TAG_NAME = "Void";

Void Void::parse(std::deque<sax::Token>::iterator& input) {
	sax::FromXMLParserHelper::popToken(input, sax::Token::TokenType::START_ELEMENT, Void::XML_TAG_NAME);
	sax::FromXMLParserHelper::popToken(input, sax::Token::TokenType::END_ELEMENT, Void::XML_TAG_NAME);
	return Void();
}

void Void::compose(std::deque<sax::Token>& out) const {
	out.emplace_back(Void::XML_TAG_NAME, sax::Token::TokenType::START_ELEMENT);
	out.emplace_back(Void::XML_TAG_NAME, sax::Token::TokenType::END_ELEMENT);
}

} /* namespace alib */

namespace alib {

xmlApi<alib::Object>::ParserRegister<alib::Void> voidParserRegister2 = xmlApi<alib::Object>::ParserRegister<alib::Void>(alib::Void::XML_TAG_NAME, alib::Void::parse);

} /* namespace alib */

