/*
 * RegExpBase.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef REG_EXP_BASE_H_
#define REG_EXP_BASE_H_

#include "../object/ObjectBase.h"
#include <set>

namespace regexp {

class RegExpBase;

// ----------------------------------------------------------------------------------------------------------------------

template<typename T>
class acceptor_base_helper {
};

template<typename ... Ts>
class acceptor_base_helper< std::tuple< Ts ... > > :
	public std::acceptor_base<
			RegExpBase, Ts ...
	> {
};

typedef acceptor_base_helper< alib::RegExpTypes > VisitableRegExpBase;

// ----------------------------------------------------------------------------------------------------------------------

/**
 * Represents symbol in an alphabet.
 */
class RegExpBase : public alib::ObjectBase, public VisitableRegExpBase {
public:
	using VisitableRegExpBase::Accept;
	using alib::VisitableObjectBase::Accept;

	virtual RegExpBase* clone() const = 0;
	virtual RegExpBase* plunder() && = 0;

	virtual const std::set<alphabet::Symbol>& getAlphabet() const = 0;
};

} /* namespace regexp */

namespace std {

template<>
struct compare<regexp::RegExpBase> {
	int operator()(const regexp::RegExpBase& first, const regexp::RegExpBase& second) const {
		return first.compare(second);
	}
};

} /* namespace std */

#endif /* REG_EXP_BASE_H_ */

