/*
 * RegExpFromXMLParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Martin Zak
 */

#ifndef REG_EXP_FROM_XML_PARSER_H_
#define REG_EXP_FROM_XML_PARSER_H_

#include "../../sax/FromXMLParserHelper.h"
#include <set>
#include "../RegExpFeatures.h"
#include "../../alphabet/SymbolFeatures.h"

namespace regexp {

/**
 * Parser used to get RegExp from XML parsed into list of tokens.
 */
class RegExpFromXMLParser : public sax::FromXMLParserHelper {
public:
	static std::set<alphabet::Symbol> parseAlphabet(std::deque<sax::Token>::iterator& input);

	static UnboundedRegExpElement* parseUnboundedRegExpElement(std::deque<sax::Token>::iterator& input);

	static UnboundedRegExpEpsilon* parseUnboundedRegExpEpsilon(std::deque<sax::Token>::iterator& input);
	static UnboundedRegExpEmpty* parseUnboundedRegExpEmpty(std::deque<sax::Token>::iterator& input);
	static UnboundedRegExpIteration* parseUnboundedRegExpIteration(std::deque<sax::Token>::iterator& input);
	static UnboundedRegExpAlternation* parseUnboundedRegExpAlternation(std::deque<sax::Token>::iterator& input);
	static UnboundedRegExpConcatenation* parseUnboundedRegExpConcatenation(std::deque<sax::Token>::iterator& input);

	static FormalRegExpElement* parseFormalRegExpElement(std::deque<sax::Token>::iterator& input);

	static FormalRegExpEpsilon* parseFormalRegExpEpsilon(std::deque<sax::Token>::iterator& input);
	static FormalRegExpEmpty* parseFormalRegExpEmpty(std::deque<sax::Token>::iterator& input);
	static FormalRegExpIteration* parseFormalRegExpIteration(std::deque<sax::Token>::iterator& input);
	static FormalRegExpAlternation* parseFormalRegExpAlternation(std::deque<sax::Token>::iterator& input);
	static FormalRegExpConcatenation* parseFormalRegExpConcatenation(std::deque<sax::Token>::iterator& input);
};

} /* namespace regexp */

#endif /* REG_EXP_FROM_XML_PARSER_H_ */
