/*
 * String.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef STRING_H_
#define STRING_H_

#include "../object/WrapperBase.h"
#include "StringBase.h"
#include "../common/wrapper.hpp"
#include <set>
#include "../alphabet/Symbol.h"

namespace string {

/**
 * Wrapper around strings.
 */
class String : public alib::wrapper<StringBase>, public alib::WrapperBase {
	using alib::wrapper<StringBase>::wrapper;
public:
	const std::set<alphabet::Symbol>& getAlphabet() const;
};

string::String stringFrom(const alphabet::Symbol& symbol);
string::String stringFrom(const std::string& str);
string::String stringFrom(const char* str);

} /* namespace string */

namespace std {

template<>
struct compare<::string::String> {
	int operator()(const ::string::String& first, const ::string::String& second) const {
		return first.getData().compare(second.getData());
	}
};

} /* namespace std */

#endif /* STRING_H_ */

