/*
 * StringBase.h
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#ifndef STRING_BASE_H_
#define STRING_BASE_H_

#include "../object/ObjectBase.h"
#include <set>
#include "../alphabet/Symbol.h"

namespace string {

class StringBase;

// ----------------------------------------------------------------------------------------------------------------------

template<typename T>
class acceptor_base_helper {
};

template<typename ... Ts>
class acceptor_base_helper< std::tuple< Ts ... > > :
	public std::acceptor_base<
			StringBase, Ts ...
	> {
};

typedef acceptor_base_helper< alib::StringTypes > VisitableStringBase;

// ----------------------------------------------------------------------------------------------------------------------

/**
 * Represents symbol in an alphabet.
 */
class StringBase : public alib::ObjectBase, public VisitableStringBase {
public:
	using VisitableStringBase::Accept;
	using alib::VisitableObjectBase::Accept;

	virtual StringBase* clone() const = 0;
	virtual StringBase* plunder() && = 0;

	virtual const std::set<alphabet::Symbol>& getAlphabet() const = 0;
};

} /* namespace string */

namespace std {

template<>
struct compare<::string::StringBase> {
	int operator()(const ::string::StringBase& first, const ::string::StringBase& second) const {
		return first.compare(second);
	}
};

} /* namespace std */

#endif /* STRING_BASE_H_ */

