/*
 * TreeBase.h
 *
 *  Created on: Nov 16, 2014
 *      Author: Stepan Plachy
 */

#ifndef TREE_BASE_H_
#define TREE_BASE_H_

#include "../object/ObjectBase.h"

namespace tree {

class TreeBase;

// ----------------------------------------------------------------------------------------------------------------------

template<typename T>
class acceptor_base_helper {
};

template<typename ... Ts>
class acceptor_base_helper< std::tuple< Ts ... > > :
	public std::acceptor_base<
			TreeBase, Ts ...
	> {
};

typedef acceptor_base_helper< alib::TreeTypes > VisitableTreeBase;

// ----------------------------------------------------------------------------------------------------------------------

/**
 * Represents symbol in an alphabet.
 */
class TreeBase : public alib::ObjectBase, public VisitableTreeBase {
public:
	using VisitableTreeBase::Accept;
	using alib::VisitableObjectBase::Accept;

	virtual TreeBase* clone() const = 0;
	virtual TreeBase* plunder() && = 0;
};

} /* namespace tree */

#endif /* TREE_BASE_H_ */

