/*
 * tuple.hpp
 *
 * Created on: Feb 28, 2014
 * Author: Jan Travnicek
 */

#ifndef TYPE_TRAITS_HPP_
#define TYPE_TRAITS_HPP_

#include <type_traits>

namespace std {

	template <typename T>
	struct is_base_of<T, T> {
		static const bool value = true;
	};

	template <typename T, typename... Ts>
	struct is_base_of_any;

	template <typename T, typename F>
	struct is_base_of_any<T, F>
	{
		static const bool value = is_base_of<T, F>::value;
	};

	template <typename T, typename F, typename... Ts>
	struct is_base_of_any<T, F, Ts...>
	{
		static const bool value = is_base_of<T, F>::value || is_base_of_any<T, Ts...>::value;
	};

	template<typename T>
	bool is_same_type(const char* name) {
		int status;

		char namespaceId[100];
		char classId[100];
		char* ret = abi::__cxa_demangle(typeid(T).name(), 0, 0, &status);
		sscanf(ret, "%[a-zA-Z]::%[a-zA-Z]", namespaceId, classId);
		free( ret );

		if(strcmp(classId, name) == 0) {
			return true;
		} else {
			return false;
		}
	}

} /* namespace std */

#endif // TYPE_TRAITS_HPP_
