#include "VectorTest.h"
#include <vector>
#include <type_traits>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( VectorTest, "bits" );
CPPUNIT_TEST_SUITE_REGISTRATION( VectorTest );

void VectorTest::setUp() {
}

void VectorTest::tearDown() {
}

void VectorTest::testVector() {
	std::ptr_vector<VectorTest::test> vector;
	std::vector<VectorTest::test*> vector2;

	for(int i = 0; i < 10; i++) {
		VectorTest::test* tmp = new VectorTest::test(i);
		vector.push_back(tmp);
		vector2.push_back(tmp);
	}

	int i = 0;
	for(VectorTest::test& tmp : vector) {
		CPPUNIT_ASSERT(tmp.get() == i);
		i++;
	}

	const decltype(vector)& vector3 = vector;

	i = 0;
	for(const VectorTest::test& tmp : vector3) {
		CPPUNIT_ASSERT(tmp.get() == i);
		i++;
	}

	i = 0;
	for(VectorTest::test& tmp : vector3) {
		CPPUNIT_ASSERT(tmp.get() == i);
		i++;
	}

	std::ptr_vector<VectorTest::test> vector4;
	for(int i = 0; i < 10; i++) {
		VectorTest::test* tmp = new VectorTest::test(i+1);
		vector4.push_back(tmp);
	}

	std::compare<std::ptr_vector<VectorTest::test>> comp;
	CPPUNIT_ASSERT(comp(vector, vector4) < 0);
}

void VectorTest::testProperties() {
	std::vector<int> data = {1, 2, 3, 4};

	const std::vector<int>& constData = data;

	CPPUNIT_ASSERT((std::is_same<decltype(constData[0]), const int&>::value));
}
